#define _CRT_SECURE_NO_WARNINGS
#define _SILENCE_CXX17_C_HEADER_DEPRECATION_WARNING
#include <bits/stdc++.h>
using namespace std;
#define CRP(t, x) const t &x
#define OPL(t, x) bool operator<(CRP(t, x)) const
#define FIL(x, v) memset(x, v, sizeof(x))
#define CLR(x) FIL(x, 0)
#define NE1(x) FIL(x, -1)
#define INF(x) FIL(x, 0x3f)
#ifndef _DEBUG
#define _DEBUG 0
#endif // !_DEBUG
#define IFD if (_DEBUG)
typedef long long ll, i64;
char mp[2005][2005];
int dp[2005];
int main()
{
    int T, n, m;
    scanf("%d", &T);
    while (T--)
    {
        scanf("%d%d", &n, &m);
        for (int i = 0; i < n; i++) scanf("%s", mp[i]);
        int ans = 0;
        for (int ch = 'A'; ch <= 'Z'; ch++)
        {
            memset(dp, 0, sizeof(dp));
            int maxsqlen = 0, prev = 0;
            for (int i = 1; i <= n; i++)
                for (int j = 1; j <= m; j++)
                {
                    int temp = dp[j];
                    if (mp[i - 1][j - 1] == ch)
                    {
                        dp[j] = min(min(dp[j - 1], prev), dp[j]) + 1;
                        maxsqlen = max(maxsqlen, dp[j]);
                    }
                    else
                        dp[j] = 0;
                    prev = temp;
                }
            ans = max(ans, maxsqlen);
        }
        printf("%d\n", ans);
    }
    return 0;
}